
const byte BrightnessRate = 25;
const byte Period = 100;

const uint16_t ONstateDelay = 30; //мс
const uint16_t OFFstateDelay = 1000; //мс

byte PeriodCounter = 0;
boolean State = false;
byte DutyCycle = 0;
byte DutyCycleCounter = 0;
  

void setup()
{ 
  DDRB = 0xFF;
  PORTB = 0xFF;

  DDRC = 0x3F;
  PORTC = 0x3F;

  DDRD = 0x7F;
  PORTD = 0x7F;
}
//------------------------------------------------------
void loop()
{ 
  delayMicroseconds(200);

  DutyCycleCounter++;
  
  if (DutyCycleCounter == BrightnessRate)
  {
    if (!State)
    {
      DutyCycle++;
      if (DutyCycle == Period)
      {
        State = true;        
      }
    }
  
    else
    {
      DutyCycle--;
      if (DutyCycle == 0)
      {
        State = false;        
      }
    }

    DutyCycleCounter = 0;
  }

  if (PeriodCounter < DutyCycle)
    All_ON();
  else
    All_OFF();

  PeriodCounter++;

  if (PeriodCounter == Period)
    PeriodCounter = 0;

  if (DutyCycle == Period)
  {
    All_ON();
    delay(ONstateDelay);
    DutyCycleCounter = BrightnessRate - 1;
    PeriodCounter = 0;
  }
  else if (DutyCycle == 0)
  {
    All_OFF();
    delay(OFFstateDelay);
    DutyCycleCounter = BrightnessRate - 1;
    PeriodCounter = 0;
  }
}
//----------------------------------------------
void All_ON()
{
  PORTB = 0;
  PORTC = 0;
  PORTD = 0x00;
}
//----------------------------------------------
void All_OFF()
{
  PORTB = 0xFF;
  PORTC = 0x3F;
  PORTD = 0x7F;
}
